package com.example.PersonalCenter.Login_Register;

import android.animation.Animator;
import android.animation.AnimatorSet;
import android.animation.ObjectAnimator;
import android.animation.PropertyValuesHolder;
import android.animation.ValueAnimator;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.animation.AccelerateDecelerateInterpolator;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;


import com.example.PersonalCenter.JellyInterpolator;
import com.example.Util.ConditionCode;
import com.example.Util.ReturnData;
import com.example.Util.ToolTip;
import com.example.Util.User;
import com.example.Util.cmkgWebServiceGet;
import com.example.Util.publicStringUtil;
import com.example.cmknowledgegraph.R;
import com.github.johnpersano.supertoasts.library.Style;
import com.github.johnpersano.supertoasts.library.SuperActivityToast;
import com.github.johnpersano.supertoasts.library.SuperToast;
import com.github.johnpersano.supertoasts.library.utils.PaletteUtils;

import java.lang.ref.WeakReference;


public class LoginActivity extends AppCompatActivity implements View.OnClickListener {
    private TextView mBtnLogin;
    private TextView getmBtnRegister;
    AnimatorSet animatorSet;
    private View progress;
    private View mInputLayout;
    private float mWidth, mHeight;
    private LinearLayout mName, mPsw;

    private final LoginHandler loginHandler = new LoginHandler(this);
//静态内部类，防止内存泄漏
    public static class LoginHandler extends Handler{
        private final WeakReference<LoginActivity> weakReference;
        LoginHandler(LoginActivity activity){
            this.weakReference = new WeakReference<LoginActivity>(activity);
        }

        @Override
        public void handleMessage(@NonNull Message msg) {
            super.handleMessage(msg);
            LoginActivity loginActivity = (LoginActivity) weakReference.get();
            Bundle bundle = msg.getData();
            ReturnData messageJSON = (ReturnData) bundle.getSerializable("msg");
            Log.i("msg",messageJSON+"");
            if(messageJSON.getCode() == ConditionCode.loginsucess) {
//                weakReference.get().mName.setVisibility(View.INVISIBLE);
//                weakReference.get().mPsw.setVisibility(View.INVISIBLE);
//                int mWidth = weakReference.get().mBtnLogin.getMeasuredWidth();
//                int mHeight =weakReference.get().mBtnLogin.getMeasuredHeight();
//
//                weakReference.get().inputAnimator(weakReference.get().mInputLayout, mWidth, mHeight);


                String ReturnUsername = (String) messageJSON.getData();



                User.setLogin(true);
                User.getUser().setUsername(ReturnUsername);
                        loginActivity.finish();



            }else {
                Log.i("fjldsk==","fasf++++");

//                这里要让那个输入输出框还原
//                weakReference.get().animatorSet.cancel();

                weakReference.get().recovery();//执行复原动作
                ToolTip.FadeCenter(weakReference.get(),messageJSON.getMsg());

            }


        }
    }




    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activity_login);

        initView();

    }
    public void initView(){
        mBtnLogin = (TextView) findViewById(R.id.main_btn_login);
        getmBtnRegister = (TextView) findViewById(R.id.main_btn_register);
        progress = findViewById(R.id.layout_progress);
        mInputLayout = findViewById(R.id.input_layout);
        mName = (LinearLayout) findViewById(R.id.id_edit);
        mPsw = (LinearLayout) findViewById(R.id.password_edit);
        //给登录设置监听

        //给登陆功能设置设置监听
        mBtnLogin.setOnClickListener(this);
        getmBtnRegister.setOnClickListener(this);
    }


    @Override
    public void onClick(View v) {
        //异步处理消息请求

        int viewID = v.getId();
        switch (viewID){
            case R.id.main_btn_login:
                //登录
                //根据监听的不同内容，来改变响应状态
                // 计算出控件的高与宽
                // 隐藏输入框

                //调入动画


                //如果登录成功

                //获取手机号和密码
                EditText phonenumberEditText = (EditText) mName.getChildAt(1);
                EditText passwordEditText = (EditText) mPsw.getChildAt(1);
                if(phonenumberEditText==null||phonenumberEditText.getText().toString().equals("")){
                    //请输入用户名
                    ToolTip.FlyTocenter(this,"请输入手机号");
                }else if(passwordEditText==null||passwordEditText.getText().toString().equals("")){
                    //请输入密码
                    ToolTip.FlyTocenter(this,"请输入密码");
                }else{
                    String phonenumber = phonenumberEditText.getText().toString();
                    String password = passwordEditText.getText().toString();
                    if(phonenumber.length()!=11 || !phonenumber.matches("[0-9]+")){
                        ToolTip.FlyTocenter(this,"请输入正确手机号码");
                    }else {
//                        基本没错误，就要请求登陆了
                        mName.setVisibility(View.INVISIBLE);
                        mPsw.setVisibility(View.INVISIBLE);
                          int mWidth = mBtnLogin.getMeasuredWidth();
                         int mHeight =mBtnLogin.getMeasuredHeight();

                        animatorSet = inputAnimator(mInputLayout, mWidth, mHeight);

                        new Thread(new Runnable() {
                            @Override
                            public void run() {
                                String argslogin = "phonenumber="+phonenumber+"&password="+password;
                                ReturnData retuData = cmkgWebServiceGet.executeHttpGet(argslogin, publicStringUtil.loginURL);
                                try {
                                    Thread.sleep(2000);
                                } catch (InterruptedException e) {
                                    e.printStackTrace();
                                }
                                Log.i("returndat--", "-----" + retuData);
                                Message m = new Message();
                                Bundle b = new Bundle();
                                b.putSerializable("msg",retuData);

                                m.setData(b);
                                loginHandler.sendMessage(m);
                            }
                        }).start();
                    }

                }



                break;
            case R.id.main_btn_register:
                //注册
                Intent intent = new Intent();
                intent.setClass(this,RegisterActivity.class);
                startActivity(intent);

        }


    }




    //设置输入框动画效果
    public  AnimatorSet inputAnimator(final View view, float w, float h){
        AnimatorSet set = new AnimatorSet();

        ValueAnimator animator = ValueAnimator.ofFloat(0, w);
        animator.addUpdateListener(new ValueAnimator.AnimatorUpdateListener() {

            @Override
            public void onAnimationUpdate(ValueAnimator animation) {
                float value = (Float) animation.getAnimatedValue();
                ViewGroup.MarginLayoutParams params = (ViewGroup.MarginLayoutParams) view
                        .getLayoutParams();
                params.leftMargin = (int) value;
                params.rightMargin = (int) value;
                view.setLayoutParams(params);
            }
        });

        ObjectAnimator animator2 = ObjectAnimator.ofFloat(mInputLayout,
                "scaleX", 1f, 0.5f);

        set.setDuration(500);
        set.setInterpolator(new AccelerateDecelerateInterpolator());
        set.playTogether(animator,animator2);


        set.addListener(new Animator.AnimatorListener() {

            @Override
            public void onAnimationStart(Animator animation) {

            }

            @Override
            public void onAnimationRepeat(Animator animation) {

            }

            @Override
            public void onAnimationEnd(Animator animation) {
                Log.i("hkfd","End方法调用了");
                progress.setVisibility(View.VISIBLE);
//                progress.setVisibility(View.GONE);
                progressAnimator(progress);
                mInputLayout.setVisibility(View.INVISIBLE);

                /**
                 * 动画结束后，先显示加载的动画，然后再隐藏输入框
                 */


            }

            @Override
            public void onAnimationCancel(Animator animation) {
                Log.i("jie","=====Cancle方法");
                progress.setVisibility(View.GONE);

            }
        });
        set.start();
        return set;

    }
    private void progressAnimator(final View view) {
        PropertyValuesHolder animator = PropertyValuesHolder.ofFloat("scaleX",
                0.5f, 1f);
        PropertyValuesHolder animator2 = PropertyValuesHolder.ofFloat("scaleY",
                0.5f, 1f);
        ObjectAnimator animator3 = ObjectAnimator.ofPropertyValuesHolder(view,
                animator, animator2);
        animator3.setDuration(500);
        animator3.setInterpolator(new JellyInterpolator());
        animator3.start();
//        animator3.cancel();

    }
    //登录错误，恢复初始状态
    private void recovery() {
        progress.setVisibility(View.INVISIBLE);
        mInputLayout.setVisibility(View.VISIBLE);
        mName.setVisibility(View.VISIBLE);
        mPsw.setVisibility(View.VISIBLE);

        ViewGroup.MarginLayoutParams params = (ViewGroup.MarginLayoutParams) mInputLayout.getLayoutParams();
        params.leftMargin = 0;
        params.rightMargin = 0;
        mInputLayout.setLayoutParams(params);


        ObjectAnimator animator2 = ObjectAnimator.ofFloat(mInputLayout, "scaleX", 0.5f,1f );
        animator2.setDuration(1000);
        animator2.setInterpolator(new AccelerateDecelerateInterpolator());
        animator2.start();
    }





}
