package com.example.PersonalCenter.Login_Register;

import android.media.Image;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.alibaba.fastjson.JSONArray;
import com.dd.CircularProgressButton;
import com.example.Util.ConditionCode;
import com.example.Util.RequestBody.user;
import com.example.Util.ReturnData;
import com.example.Util.ToolTip;
import com.example.Util.User;
import com.example.Util.cmkgWebServicePost;
import com.example.Util.publicStringUtil;
import com.example.cmknowledgegraph.R;
import com.hanks.library.AnimateCheckBox;
import com.itheima.wheelpicker.WheelPicker;

import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class RegisterActivity extends AppCompatActivity implements View.OnClickListener {
    private EditText phonenumberRegister;
    private EditText usernameRegister;
    private EditText passwordRegister;
    private TextView RegisterButton;
    private ImageView boycheckimg;
    private ImageView girlcheckimg;
    private AnimateCheckBox boycheck;
    private AnimateCheckBox girlcheck;
    private WheelPicker wheelPicker;



    private final RegisterHandler registerHandler = new RegisterHandler(this);
    public static class RegisterHandler extends Handler{
        private final WeakReference<RegisterActivity> weakReference;
        RegisterHandler(RegisterActivity registerActivity){
            this.weakReference = new WeakReference<RegisterActivity>(registerActivity);
        }
        @Override
        public void handleMessage(@NonNull Message msg) {
            super.handleMessage(msg);
            RegisterActivity registerActivity = (RegisterActivity) weakReference.get();
            Bundle bundle = msg.getData();

            ReturnData returnData = (ReturnData) bundle.getSerializable("msg");

            if(returnData!=null && returnData.getCode()!=null){
                int code = returnData.getCode();
                if(code == ConditionCode.registersucess){
                    try {
                        Thread.sleep(700);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    ToolTip.FadeCenter(weakReference.get(),"注册成功！");
                    weakReference.get().finish();
                }else {
                    ToolTip.FlyTocenter(weakReference.get(),returnData.getMsg());
                }
            }else ToolTip.FlyTocenter(weakReference.get(),"服务器出了点小问题");




        }
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activity_register);
        initView();

    }

    private void initView() {
        //获取各个控件
        RegisterButton = findViewById(R.id.main_btn_register_but);
        boycheck = findViewById(R.id.boycheck);
        boycheckimg = findViewById(R.id.boycheckimg);
        girlcheck = findViewById(R.id.girlcheck);
        girlcheckimg = findViewById(R.id.girlcheckimg);
        phonenumberRegister = findViewById(R.id.phonenumber_edit_register);
        usernameRegister = findViewById(R.id.username_edit_register);
        passwordRegister = findViewById(R.id.password_edit_register);

        //给控件设置监听器
        boycheck.setOnClickListener(this);
        boycheckimg.setOnClickListener(this);
        girlcheckimg.setOnClickListener(this);
        girlcheck.setOnClickListener(this);
        RegisterButton.setOnClickListener(this);
        List<String> agewhellList = new ArrayList<String>();
        for(int i=0;i<120;i++) agewhellList.add(i+"");



//        wheelPicker.run();

    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id){
            case R.id.boycheck:
            case R.id.boycheckimg:
                if(!girlcheck.isChecked()){
                    if(boycheck.isChecked()) boycheck.setChecked(false); else boycheck.setChecked(true);
                }
                break;
            case R.id.girlcheck:
            case R.id.girlcheckimg:
                if(!boycheck.isChecked()) {
                    if(girlcheck.isChecked()) girlcheck.setChecked(false);  else girlcheck.setChecked(true);
                }
                break;
            case R.id.main_btn_register_but:
                Log.i("haha","你要注册了");
               checkInfo();

        }
    }
    public void checkInfo(){
//        先检查手机号
        String phonenumber = phonenumberRegister.getText().toString();

        if(phonenumber == null || phonenumber.length()!=11 || !phonenumber.matches("[0-9]+")){
            ToolTip.FadeCenter(this,"请输入正确的手机号");

        }else{
            String username = usernameRegister.getText().toString();
            if(username == null){
                ToolTip.FadeCenter(this,"请输入用户名");
            }else if(username.length()>14) ToolTip.FadeCenter(this,"用户名过长");
            else {
                String password = passwordRegister.getText().toString();
                if(password == null){
                    ToolTip.FadeCenter(this,"请输入密码");
                }else if(password.length()<6) ToolTip.FadeCenter(this, "密码至少为6位");
                else if(password.length()>14) ToolTip.FadeCenter(this," 密码最多14位");
                else {
                    if(boycheck.isChecked()){
                        user user = new user(phonenumber,username,password,0,0,"");

                        new Thread(new Runnable() {
                            @Override
                            public void run() {
                                Message m = new Message();
                                Bundle bundle = new Bundle();

                                ReturnData returnData = cmkgWebServicePost.execuHttpPost(user.toString(), publicStringUtil.registerURL);
                                Log.i("returndata",""+returnData);
                                bundle.putSerializable("msg", returnData);
                                m.setData(bundle);
                                registerHandler.sendMessage(m);

                            }
                        }).start();
                    }else if(girlcheck.isChecked()){
                        String args =  "phonenumber="+phonenumber+"&username="+username+"&password="+password
                                +"&region="+""+"&age=0"+"&sex=0";
                        cmkgWebServicePost.execuHttpPost(args, publicStringUtil.registerURL);
                        new Thread(new Runnable() {
                            @Override
                            public void run() {
                                Message message = new Message();
                                Bundle bundle = new Bundle();
                                ReturnData returnData = cmkgWebServicePost.execuHttpPost(args,publicStringUtil.registerURL);
                                bundle.putSerializable("msg", returnData);
                                message.setData(bundle);
                                registerHandler.sendMessage(message);
                            }
                        }).start();
                    }else{
                        ToolTip.FadeCenter(this,"请选择性别");
                    }
                }
            }
        }


    }


}
